      function final(par)
************************************************************************
*                                                                      *
*     Write out the data and the fit to it.                            *
*     Version of Jan 19, 1999.                                         *
*                                                                      *
************************************************************************
$include vers.h
$include apeno.h
$include grids.h
$include gss32.h
$include datacom.h
$include dsped.h
      character*4 flag
      dimension y(meqn*mxgrd), f(meqn), chi(mexp), n(mexp)
      double precision par(*)
      parameter (ngs=16)
      common /gauss2/ wgs(ngs), xgs(ngs)
      common /extras/ eps, h1, hmin, alsq, neqn
************************************************************************
*                                                                      *
*     Initialise to write out the fit to data.                         *
*                                                                      *
************************************************************************
      nf=neff(0)
      positive=-1.0
      call initg1(y,par,positive)
      call spline(y)
*
      do 10 iexp=1,nexp
         n(iexp)=0
 10      chi(iexp)=0.
*
      do 20 iq=1,nqgrd
         if (neff(iq).ne.nf) then
            nf=neff(iq)
            go to 20
         end if
************************************************************************
*        At the special point write out parton densities, Bjorken sum. *
************************************************************************
         if (iq.eq.kfin) then
            do 29 x=0.01,1.00,0.01
               call splint(x,f)
               uqk=f(nq0)/4+f(nq3)/2+f(nq8)/6+f(nq15)/12
               dqk=f(nq0)/4-f(nq3)/2+f(nq8)/6+f(nq15)/12
               sqk=f(nq0)/4         -f(nq8)/3+f(nq15)/12
               cqk=f(nq0)/4                  -f(nq15)/4
 29            write(1,'(8e12.4)') x, f(nu), f(nd), f(ng), uqk, dqk,
     1            sqk, cqk
         end if
************************************************************************
*        Write out the fit to data.                                    *
************************************************************************
         do 21 iexp=1,nexp
            kode=key(iexp)
            if (kode.eq.kprot) then
               flag='prot'
            else if (kode.eq.kdeut) then
               flag='deut'
            else if (kode.eq.kneut) then
               flag='neut'
            else
               go to 21
            end if
            do 22 ix=1,ndx
               iptr=indx(ix,iexp,iq)
               if (iptr.gt.0.0) then
                  a1=g1(iq,ix,kode)
                  write(*,'(a3,i2,6e12.4,2x,a4)') 'EXP', iexp, q2(iq),
     1               xd(ix), d(iptr),sqrt(sg(iptr)), a1,fun(iptr),flag
                  n(iexp)=n(iexp)+1
                  chi(iexp)=chi(iexp)+(d(iptr)-a1)**2/sg(iptr)
               end if
 22            continue
 21         continue
 20      continue
*
      do 30 iexp=1,nexp
 30      write(*,'(a,i3,a,e12.4,a,i6,a)') '# chi(',iexp,') = ',
     1      chi(iexp), ' / ', n(iexp), ' DOF'
*
      write(*,'(a,f7.3,a)') 'Version ', vers, ' run over'
*
      return
      end
